#include "main.h"
#include "24bit.h"

unsigned char* colors;
unsigned int colorLen = 0xffffff + 1;

DWORD WINAPI colorThread24(void* data) {
    unsigned int i;
    pixelainfo_t* part = (pixelainfo_t*) data;
    for(i = 0; i < part->length; i++) {
        colors[*(part->start + i) & 0xffffff] = 1;
    }
    return 0;
}

DWORD WINAPI additionThread24(void* data) {
    unsigned int i;
    countinfo_t* part = (countinfo_t*) data;
    part->ret = 0;
    for(i = 0; i < part->length; i++) {
        part->ret += colors[part->start + i];
    }
    return 0;
}

long DLL_EXPORT getColorCount24(unsigned int* pixel, int len) {
    int i;
    long colorSum = 0;
    colors = (unsigned char*) calloc(colorLen, sizeof(unsigned char));
    HANDLE threads[THREADS];
    pixelainfo_t* pixelparts[THREADS];
    countinfo_t* countparts[THREADS];

    for(i = 0; i < THREADS; i++) {
        /* partitioning pixel map and sum map, also start color count threads */
        pixelparts[i] = (pixelainfo_t*) malloc(sizeof(pixelainfo_t));
        pixelparts[i]->start = pixel + i * (len / THREADS);
        pixelparts[i]->length = len / THREADS;
        threads[i] = CreateThread(NULL, 0, colorThread24, pixelparts[i], 0, NULL);
        countparts[i] = (countinfo_t*) malloc(sizeof(countinfo_t));
        countparts[i]->start = i * (colorLen / THREADS);
        countparts[i]->length = colorLen / THREADS;
    }
    /* wait for color count threads (JOIN) */
    WaitForMultipleObjects(THREADS, threads, TRUE, INFINITE);
    for(i = 0; i < THREADS; i++) {
        /* close color count threads, start addition threads */
        CloseHandle(threads[i]);
        free(pixelparts[i]);
        threads[i] = CreateThread(NULL, 0, additionThread24, countparts[i], 0, NULL);
    }
    /* wait for addition threads (JOIN) */
    WaitForMultipleObjects(THREADS, threads, TRUE, INFINITE);
    for(i = 0; i < THREADS; i++) {
        /* close addition threads, calculate final sum from parts */
        CloseHandle(threads[i]);
        colorSum += countparts[i]->ret;
        free(countparts[i]);
    }
    free(colors);
    return colorSum;
}
