#include "main.h"
#include "32bit.h"

unsigned short* colors32;
unsigned int colorLen32 = 0xfffffff + 1; //28 bit

__inline int numberOfSetBits(unsigned int i) {
    /* here be dragons */
    i = i - ((i >> 1) & 0x55555555);
    i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
    return (((i + (i >> 4)) & 0x0F0F0F0F) * 0x01010101) >> 24;
}

DWORD WINAPI colorThread32(void* data) {
    unsigned int i;
    pixelainfo_t* part = (pixelainfo_t*) data;
    for(i = 0; i < part->length; i++) {
        colors32[*(part->start + i) & 0x0fffffff] |= 1 << ((*(part->start + i) & 0xf0000000) >> 28);
    }
    return 0;
}

DWORD WINAPI additionThread32(void* data) {
    unsigned int i;
    countinfo_t* part = (countinfo_t*) data;
    part->ret = 0;
    for(i = 0; i < part->length; i++) {
        part->ret += numberOfSetBits(colors32[part->start + i]);
    }
    return 0;
}

long DLL_EXPORT getColorCount32(unsigned int* pixel, int len) {
    int i;
    long colorSum = 0;
    colors32 = (unsigned short*) calloc(colorLen32, sizeof(unsigned short));
    HANDLE threads[THREADS];
    pixelainfo_t* pixelparts[THREADS];
    countinfo_t* countparts[THREADS];

    for(i = 0; i < THREADS; i++) {
        /* partitioning pixel map and sum map, also start color count threads */
        pixelparts[i] = (pixelainfo_t*) malloc(sizeof(pixelainfo_t));
        pixelparts[i]->start = pixel + i * (len / THREADS);
        pixelparts[i]->length = len / THREADS;
        threads[i] = CreateThread(NULL, 0, colorThread32, pixelparts[i], 0, NULL);
        countparts[i] = (countinfo_t*) malloc(sizeof(countinfo_t));
        countparts[i]->start = i * (colorLen32 / THREADS);
        countparts[i]->length = colorLen32 / THREADS;
    }
    /* wait for color count threads (JOIN) */
    WaitForMultipleObjects(THREADS, threads, TRUE, INFINITE);
    for(i = 0; i < THREADS; i++) {
        /* close color count threads, start addition threads */
        CloseHandle(threads[i]);
        free(pixelparts[i]);
        threads[i] = CreateThread(NULL, 0, additionThread32, countparts[i], 0, NULL);
    }
    /* wait for addition threads (JOIN) */
    WaitForMultipleObjects(THREADS, threads, TRUE, INFINITE);
    for(i = 0; i < THREADS; i++) {
        /* close addition threads, calculate final sum from parts */
        CloseHandle(threads[i]);
        colorSum += countparts[i]->ret;
        free(countparts[i]);
    }
    free(colors32);
    return colorSum;
}
